<template>
    <el-collapse-item v-if="value" :name="`team.${memberId}.`">
        <template v-slot:title>
            <div :class="headerClass">
                <span>{{memberFullName}}</span>
                <template v-if="isEditable">
                    <template v-if="!isDeletedOrEdited">
                        <i class="el-icon-delete" @click.stop="deleteMember"></i>
                        <i :class="editIconClasses" @click.stop="switchEditMode"></i>
                    </template>
                    <i v-else class="el-icon-refresh" @click.stop="discardChanges"></i>
                </template>
            </div>
        </template>
        <diff-table v-model="value" :diff-data="initData" :id="id" :editMode="isEditMode" :path="editParamsPath" :editableParams="editableParams"
            @edited="editHandler" />
    </el-collapse-item>
</template>

<script>
import DiffTable from '@/components/tables/DiffTable';
import { mapState } from 'vuex';
import { teamEditParams } from '@/constants/ui/details';

export default {
    components: {
        DiffTable,
    },
    props: {
        /** team member id */
        memberId: {
            type: [String, Number],
            required: true,
        },
        /** team member data from server */
        initData: {
            type: Object,
            required: true,
        },
    },
    computed: {
        editParamsPath: vm => ({ root: 'pending_profile', field: 'team', index: vm.memberId }),
        isEditable: vm => vm.$store.getters.isEditable(vm.editParamsPath.root, vm.editParamsPath.field),
        id: vm => `${vm.editParamsPath.field}:${vm.memberId}`,
        editableParams: () => teamEditParams,
        memberFullName: (vm) => {
            const { member_firstName: firstName, member_lastName: lastName } = vm.initData.published;
            if (firstName || lastName) {
                return `Member #${vm.memberId + 1}: ${firstName} ${lastName}`;
            }
            const { member_firstName: newFirstName, member_lastName: newLastName } = vm.initData.pending;
            return `Member #${vm.memberId + 1}: ${newFirstName} ${newLastName} [not approved]`;
        },
        headerClass: vm => ({ header_common: true, header_deleted: vm.isDeleted }),
        isDeleted: vm => Boolean(vm.$store.getters.isTeamMemberDeleted(vm.memberId)),
        isEdited: vm => vm.$store.getters.isTeamMemberEdited(vm.id),
        isEditMode: vm => vm.$store.getters.isEditEnabledForTeamMember(vm.memberId),
        isDeletedOrEdited: vm => vm.isDeleted || vm.isEdited,
        editIconClasses: vm => ({ 'el-icon-edit': true, 'edit-on': vm.isEditMode }),
        ...mapState({
            value(state) { return state.editUser.profileTeam[this.memberId]; },
        }),
    },
    methods: {
        /**
         * Handler for deleting member: save deleted member in store
         */
        deleteMember() {
            this.$store.commit('deleteTeamMember', this.memberId);
            this.$emit('deleted', this.memberId);
        },
        /**
         * Handler for switching edit mode for team member
         */
        switchEditMode() {
            this.$store.commit('enableEditForTeamMember', { id: this.memberId, status: !this.isEditMode });
        },
        /**
         * Handler for discaring changes
         */
        discardChanges() {
            if (this.initData && this.initData.pending) {
                this.$store.commit('restoreTeamMember', { id: this.memberId, member: this.initData.pending });
                this.$store.commit('clearEditedFields', [this.id]);
                this.$store.commit('clearValidationMessage', { path: ['pending_profile', 'team'], id: this.memberId });
            }
        },
        /**
         * Callback for editing member's data inside DiffTable
         * @param {Object} editData - options of the edited parameter
         */
        editHandler(editData) {
            this.$store.commit('updatePendingProfileParam', editData);
            this.$store.commit('updateEditedFields', editData);
        },
    },
};
</script>

<style lang="stylus" scoped>
.el-collapse-item
    margin: 1rem

>>> .el-collapse-item__header
    font-size: 1.8rem
    color: $dark_gray !important
    :hover
        background-color $bg_light_gray

.el-icon-delete, .el-icon-refresh, .el-icon-edit
    vertical-align: middle
    float: right
    line-height: 48px
    margin-right: 2rem
    color: $base_blue

.el-icon-delete:hover, .el-icon-refresh:hover, .el-icon-edit:hover
    color: $title_blue

.header_common
    width: 100%
    text-decoration: none

.header_deleted
    text-decoration: line-through
    color: $base_gray

.edit-on, .el-icon-refresh
    color: $dark_gray
    font-size: 2rem

</style>
